#include "xlib_cairo_window.h"
//#include <cairo.h>
//#include <X11/Xlib.h>

point xlib_window::current() { return p; }
void xlib_window::current(const point& cp) { 
	p=cp;
	cairo_move_to (cr, p.x, p.y);
}
void xlib_window::line(const point& p1) { 
	cairo_move_to (cr, p.x, p.y);
	cairo_line_to (cr, p1.x, p1.y);
	p=p1;
	cairo_stroke (cr);
}
void xlib_window::paint() {
	XEvent e;
	cairo_show_page(cr);
	while(1) {
		XNextEvent(dpy, &e);
		if(e.type==Expose && e.xexpose.count<1) {
			//paint(cs);
		} else if(e.type==ButtonPress) break;
	}
}

xlib_window::xlib_window(int x,int y,const char* pc):p(0,0){
	if(!(dpy=XOpenDisplay(NULL))) {
		std::cerr<<"ERROR: Could not open display"<<std::endl;
		exit(1);
	}
	scr=DefaultScreen(dpy);
	rootwin=RootWindow(dpy, scr);

	win=XCreateSimpleWindow(dpy, rootwin, 1, 1, x, y, 0, 
			BlackPixel(dpy, scr), BlackPixel(dpy, scr));
	XStoreName(dpy, win, pc);
	XSelectInput(dpy, win, ExposureMask|ButtonPressMask);
	XMapWindow(dpy, win);
   	surface=cairo_xlib_surface_create(dpy, win, 
			DefaultVisual(dpy, 0), x, y);
        cr = cairo_create (surface);

        cairo_set_source_rgb (cr, 0.0, 0.0, 1.0);
	cairo_set_line_width (cr, 2);

}

xlib_window::~xlib_window(){
        cairo_destroy (cr);
        cairo_surface_destroy (surface);
	XCloseDisplay(dpy);
}

