#include <iostream>
using std::cout;
using std::endl;
#include <cairo.h>
#include <X11/Xlib.h>
#define SIZEX 500
#define SIZEY  300
#include<cairo-xlib.h>


int main() {	Display *dpy;
	Window rootwin;
	Window win;
	XEvent e;
	int scr;
//	cairo_surface_t *cs;

	if(!(dpy=XOpenDisplay(NULL))) {
		fprintf(stderr, "ERROR: Could not open display\n");
		exit(1);
	}

	scr=DefaultScreen(dpy);
	rootwin=RootWindow(dpy, scr);

	win=XCreateSimpleWindow(dpy, rootwin, 1, 1, SIZEX, SIZEY, 0, 
			BlackPixel(dpy, scr), BlackPixel(dpy, scr));

	XStoreName(dpy, win, "hello");
	XSelectInput(dpy, win, ExposureMask|ButtonPressMask);
	XMapWindow(dpy, win);

      cairo_surface_t *surface;
   	surface=cairo_xlib_surface_create(dpy, win, DefaultVisual(dpy, 0), SIZEX, SIZEY);
     cairo_t *cr;

//        surface = cairo_image_surface_create (CAIRO_FORMAT_ARGB32, 240, 80);
        cr = cairo_create (surface);

        cairo_select_font_face (cr, "serif", CAIRO_FONT_SLANT_NORMAL, CAIRO_FONT_WEIGHT_BOLD);
        cairo_set_font_size (cr, 32.0);
        cairo_set_source_rgb (cr, 0.0, 0.0, 1.0);
        cairo_move_to (cr, 10.0, 50.0);
        cairo_show_text (cr, "Hello, world");
        cairo_destroy (cr);
        cairo_surface_write_to_png (surface, "hello.png");
	int i=0;
	while(1) {
		XNextEvent(dpy, &e);
		if(e.type==Expose && e.xexpose.count<1) {
			cout<<i++<<endl;
			//paint(cs);
		} else if(e.type==ButtonPress) break;
	}

        cairo_surface_destroy (surface);
	XCloseDisplay(dpy);
        return 0;
}
